#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/telepathy-glib.h>


G_BEGIN_DECLS

typedef struct _EmpSvcChannelInterfaceCredentialsStorage EmpSvcChannelInterfaceCredentialsStorage;

typedef struct _EmpSvcChannelInterfaceCredentialsStorageClass EmpSvcChannelInterfaceCredentialsStorageClass;

GType emp_svc_channel_interface_credentials_storage_get_type (void);
#define EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE \
  (emp_svc_channel_interface_credentials_storage_get_type ())
#define EMP_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE, EmpSvcChannelInterfaceCredentialsStorage))
#define EMP_IS_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE))
#define EMP_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_CHANNEL_INTERFACE_CREDENTIALS_STORAGE, EmpSvcChannelInterfaceCredentialsStorageClass))


typedef void (*emp_svc_channel_interface_credentials_storage_store_credentials_impl) (EmpSvcChannelInterfaceCredentialsStorage *self,
    gboolean in_Store,
    DBusGMethodInvocation *context);
void emp_svc_channel_interface_credentials_storage_implement_store_credentials (EmpSvcChannelInterfaceCredentialsStorageClass *klass, emp_svc_channel_interface_credentials_storage_store_credentials_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_channel_interface_credentials_storage_return_from_store_credentials (DBusGMethodInvocation *context);
static inline void
emp_svc_channel_interface_credentials_storage_return_from_store_credentials (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}


typedef struct _EmpSvcLogger EmpSvcLogger;

typedef struct _EmpSvcLoggerClass EmpSvcLoggerClass;

GType emp_svc_logger_get_type (void);
#define EMP_TYPE_SVC_LOGGER \
  (emp_svc_logger_get_type ())
#define EMP_SVC_LOGGER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), EMP_TYPE_SVC_LOGGER, EmpSvcLogger))
#define EMP_IS_SVC_LOGGER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), EMP_TYPE_SVC_LOGGER))
#define EMP_SVC_LOGGER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), EMP_TYPE_SVC_LOGGER, EmpSvcLoggerClass))


typedef void (*emp_svc_logger_get_favourite_contacts_impl) (EmpSvcLogger *self,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_get_favourite_contacts (EmpSvcLoggerClass *klass, emp_svc_logger_get_favourite_contacts_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_get_favourite_contacts (DBusGMethodInvocation *context,
    const GPtrArray *out_Favourite_Contacts);
static inline void
emp_svc_logger_return_from_get_favourite_contacts (DBusGMethodInvocation *context,
    const GPtrArray *out_Favourite_Contacts)
{
  dbus_g_method_return (context,
      out_Favourite_Contacts);
}

typedef void (*emp_svc_logger_add_favourite_contact_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_add_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_add_favourite_contact_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_add_favourite_contact (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_add_favourite_contact (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_remove_favourite_contact_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_remove_favourite_contact (EmpSvcLoggerClass *klass, emp_svc_logger_remove_favourite_contact_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_remove_favourite_contact (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_remove_favourite_contact (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_clear_impl) (EmpSvcLogger *self,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_clear (EmpSvcLoggerClass *klass, emp_svc_logger_clear_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_clear (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_clear (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_clear_account_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_clear_account (EmpSvcLoggerClass *klass, emp_svc_logger_clear_account_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_clear_account (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_clear_account (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*emp_svc_logger_clear_entity_impl) (EmpSvcLogger *self,
    const gchar *in_Account,
    const gchar *in_Identifier,
    gint in_Type,
    DBusGMethodInvocation *context);
void emp_svc_logger_implement_clear_entity (EmpSvcLoggerClass *klass, emp_svc_logger_clear_entity_impl impl);
static inline
/* this comment is to stop gtkdoc realising this is static */
void emp_svc_logger_return_from_clear_entity (DBusGMethodInvocation *context);
static inline void
emp_svc_logger_return_from_clear_entity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void emp_svc_logger_emit_favourite_contacts_changed (gpointer instance,
    const gchar *arg_Account,
    const gchar **arg_Added,
    const gchar **arg_Removed);


G_END_DECLS
